(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('@xtream/ngx-validation-errors', ['exports', '@angular/core', '@angular/forms', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory((global.xtream = global.xtream || {}, global.xtream['ngx-validation-errors'] = {}), global.ng.core, global.ng.forms, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, forms, rxjs, operators, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var ValidationErrorsConfigObject = new core.InjectionToken('ValidationErrorsConfigObject');
    var FOR_ROOT_OPTIONS_TOKEN = new core.InjectionToken('forRootOptionToken');
    var MESSAGES_PROVIDER = new core.InjectionToken('MessagesProvider');
    var MESSAGES_PIPE_FACTORY_TOKEN = new core.InjectionToken('MessagePipeFactoryToken');

    var InputErrorsComponent = /** @class */ (function () {
        function InputErrorsComponent() {
            this.messages = [];
            this.params = {};
        }
        __decorate([
            core.Input()
        ], InputErrorsComponent.prototype, "messages", void 0);
        __decorate([
            core.Input()
        ], InputErrorsComponent.prototype, "params", void 0);
        __decorate([
            core.Input(), core.HostBinding('class.is-inner')
        ], InputErrorsComponent.prototype, "innerValidationError", void 0);
        __decorate([
            core.Input()
        ], InputErrorsComponent.prototype, "control", void 0);
        InputErrorsComponent = __decorate([
            core.Component({
                // tslint:disable-next-line:component-selector
                selector: 'input-errors',
                template: "\n      <div class=\"error-wrapper\">\n          <span\n              class=\"help-block\"\n              *ngFor=\"let message of messages;\"\n          >{{ message | mapToMessage: params }}</span>\n      </div>\n  ",
                styles: [":host{position:absolute}:host .error-wrapper{position:relative;left:41px;bottom:2px}:host .error-wrapper span{font-size:.8em;color:red;font-weight:500}:host(.is-inner){position:absolute}:host(.is-inner) .error-wrapper{position:relative;left:37px;bottom:20px}:host(.is-inner) .error-wrapper span{font-size:.8em;color:red;font-weight:500}"]
            })
        ], InputErrorsComponent);
        return InputErrorsComponent;
    }());

    function toScreamingSnakeCase(input) {
        return input.replace(/([a-z])([A-Z])/g, '$1_$2').toUpperCase();
    }

    function wrapMethod(subject$, name, control) {
        var prevMethod = control[name];
        function wrappedMethod() {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            prevMethod.bind(control).apply(void 0, __spread(args));
            subject$.next();
        }
        control[name] = wrappedMethod;
    }
    function toChangeObservable(control) {
        var touchedChanges$ = new rxjs.Subject();
        wrapMethod(touchedChanges$, 'markAsTouched', control);
        wrapMethod(touchedChanges$, 'markAsUntouched', control);
        wrapMethod(touchedChanges$, 'markAsDirty', control);
        wrapMethod(touchedChanges$, 'markAsPristine', control);
        var obs = rxjs.merge(touchedChanges$, control.statusChanges);
        return obs.pipe(operators.debounceTime(100));
    }

    var FormValidationContainer = /** @class */ (function () {
        function FormValidationContainer(elRef, renderer, messageProvider, cdRef, componentFactoryResolver, validationErrorsConfig) {
            this.elRef = elRef;
            this.renderer = renderer;
            this.messageProvider = messageProvider;
            this.cdRef = cdRef;
            this.componentFactoryResolver = componentFactoryResolver;
            this.validationErrorsConfig = validationErrorsConfig;
            this.customErrorMessages = {};
            this.messageParams = {};
            this.validationDisabled = false;
            this.validationContext = validationErrorsConfig.defaultContext;
        }
        FormValidationContainer.prototype.ngAfterContentInit = function () {
            var _this = this;
            this.addErrorComponent();
            this.subscription = toChangeObservable(this.formControl).subscribe(function (value) {
                _this.checkErrors();
                _this.checkSuccess();
                _this.updateErrorComponent();
            });
        };
        FormValidationContainer.prototype.ngOnDestroy = function () {
            if (this.subscription) {
                this.subscription.unsubscribe();
            }
        };
        FormValidationContainer.prototype.addErrorComponent = function () {
            if (this.errorsContainer && !this.componentRef) {
                this.errorsContainer.clear();
                var componentFactory = this.componentFactoryResolver.resolveComponentFactory(this.validationErrorsConfig.errorComponent);
                this.componentRef = this.errorsContainer.createComponent(componentFactory);
            }
        };
        FormValidationContainer.prototype.updateErrorComponent = function () {
            if (this.componentRef) {
                this.componentRef.instance.innerValidationError = this.innerValidationError;
                this.componentRef.instance.messages = this.messages;
                this.componentRef.instance.params = this.messageParams;
            }
        };
        FormValidationContainer.prototype.checkErrors = function () {
            var _this = this;
            var hasError = (!this.formControl.valid && this.formControl.dirty && this.formControl.touched) && !this.validationDisabled;
            if (hasError && this.el && this.el.nativeElement) {
                this.messages = Object.keys(this.formControl.errors).map(function (error) {
                    var fieldName = _this.formControlName;
                    var errorKey = toScreamingSnakeCase(fieldName + '') + ".ERRORS." + toScreamingSnakeCase(error);
                    if (_this.messageProvider &&
                        _this.messageProvider.instant(_this.validationContext + "." + errorKey) === _this.validationContext + "." + errorKey) {
                        return _this.validationErrorsConfig.defaultContext + ".ERRORS." + toScreamingSnakeCase(error);
                    }
                    else {
                        return _this.validationContext + "." + errorKey;
                    }
                });
                var params = Object.values(this.formControl.errors).reduce(function (a, b) {
                    a = __assign(__assign({}, a), b);
                    return a;
                }, {});
                this.messageParams = this.messageParams ? __assign(__assign({}, this.messageParams), params) : params;
                if (this.messages && this.messages.length > 0) {
                    this.messages = [this.messages[0]];
                }
                try {
                    this.renderer.removeClass(this.el.nativeElement, 'is-valid');
                }
                catch (e) {
                }
                this.renderer.addClass(this.el.nativeElement, 'is-invalid');
            }
            this.hasErrors = hasError;
        };
        FormValidationContainer.prototype.checkSuccess = function () {
            var hasSuccess = (this.formControl.valid &&
                this.formControl.dirty && this.formControl.touched) &&
                !this.validationDisabled;
            if (hasSuccess && this.el && this.el.nativeElement) {
                this.messages = [];
                try {
                    this.renderer.removeClass(this.el.nativeElement, 'is-invalid');
                }
                catch (e) {
                }
            }
            this.hasSuccess = hasSuccess;
        };
        FormValidationContainer.prototype.setValidationContext = function (context) {
            this.validationContext = context;
        };
        FormValidationContainer.prototype.setInnerValidation = function (innerValidation) {
            this.innerValidationError = innerValidation;
        };
        FormValidationContainer.prototype.clear = function () {
            this.formControl.reset();
            this.formControl.setErrors(null);
            this.renderer.removeClass(this.el.nativeElement, 'is-valid');
            this.renderer.removeClass(this.el.nativeElement, 'is-invalid');
            this.messages = [];
        };
        __decorate([
            core.Input()
        ], FormValidationContainer.prototype, "customErrorMessages", void 0);
        __decorate([
            core.Input()
        ], FormValidationContainer.prototype, "messageParams", void 0);
        __decorate([
            core.Input()
        ], FormValidationContainer.prototype, "validationDisabled", void 0);
        __decorate([
            core.Input()
        ], FormValidationContainer.prototype, "innerValidationError", void 0);
        __decorate([
            core.ViewChild('errorsContainer', { read: core.ViewContainerRef, static: true })
        ], FormValidationContainer.prototype, "errorsContainer", void 0);
        __decorate([
            core.HostBinding('class.has-error')
        ], FormValidationContainer.prototype, "hasErrors", void 0);
        __decorate([
            core.HostBinding('class.has-success')
        ], FormValidationContainer.prototype, "hasSuccess", void 0);
        return FormValidationContainer;
    }());

    var VALIDATION_ERROR_CONFIG = new core.InjectionToken('validationError.config');

    var FormFieldContainerComponent = /** @class */ (function (_super) {
        __extends(FormFieldContainerComponent, _super);
        function FormFieldContainerComponent(
        // tslint:disable-next-line:variable-name
        _elRef, 
        // tslint:disable-next-line:variable-name
        _renderer, 
        // tslint:disable-next-line:variable-name
        _messageProvider, 
        // tslint:disable-next-line:variable-name
        _cdRef, 
        // tslint:disable-next-line:variable-name
        _componentFactoryResolver, 
        // tslint:disable-next-line:variable-name
        _validationErrorsConfig) {
            var _this = _super.call(this, _elRef, _renderer, _messageProvider, _cdRef, _componentFactoryResolver, _validationErrorsConfig) || this;
            _this._elRef = _elRef;
            _this._renderer = _renderer;
            _this._messageProvider = _messageProvider;
            _this._cdRef = _cdRef;
            _this._componentFactoryResolver = _componentFactoryResolver;
            _this._validationErrorsConfig = _validationErrorsConfig;
            return _this;
        }
        Object.defineProperty(FormFieldContainerComponent.prototype, "formControl", {
            get: function () {
                return this._formControl.control;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormFieldContainerComponent.prototype, "formControlName", {
            get: function () {
                return this._formControl.name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormFieldContainerComponent.prototype, "statusChanges", {
            get: function () {
                return this._formControl.control.statusChanges;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormFieldContainerComponent.prototype, "el", {
            get: function () {
                return this._input;
            },
            enumerable: true,
            configurable: true
        });
        FormFieldContainerComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MESSAGES_PROVIDER,] }] },
            { type: core.ChangeDetectorRef },
            { type: core.ComponentFactoryResolver },
            { type: undefined, decorators: [{ type: core.Inject, args: [VALIDATION_ERROR_CONFIG,] }] }
        ]; };
        __decorate([
            core.ContentChild(forms.FormControlName, { static: true })
        ], FormFieldContainerComponent.prototype, "_formControl", void 0);
        __decorate([
            core.ContentChild(forms.FormControlName, { read: core.ElementRef, static: true })
        ], FormFieldContainerComponent.prototype, "_input", void 0);
        FormFieldContainerComponent = __decorate([
            core.Component({
                selector: '[ngxValidationErrorsField], ngx-validation-errors-field, [formFieldContainer], form-field-container',
                template: "\n      <ng-content></ng-content>\n      <ng-template #errorsContainer></ng-template>\n  "
            }),
            __param(2, core.Optional()), __param(2, core.Inject(MESSAGES_PROVIDER)),
            __param(5, core.Inject(VALIDATION_ERROR_CONFIG))
        ], FormFieldContainerComponent);
        return FormFieldContainerComponent;
    }(FormValidationContainer));

    var FormArrayContainerComponent = /** @class */ (function (_super) {
        __extends(FormArrayContainerComponent, _super);
        function FormArrayContainerComponent(
        // tslint:disable-next-line:variable-name
        _elRef, 
        // tslint:disable-next-line:variable-name
        _renderer, 
        // tslint:disable-next-line:variable-name
        _messageProvider, 
        // tslint:disable-next-line:variable-name
        _cdRef, 
        // tslint:disable-next-line:variable-name
        _componentFactoryResolver, 
        // tslint:disable-next-line:variable-name
        _validationErrorsConfig) {
            var _this = _super.call(this, _elRef, _renderer, _messageProvider, _cdRef, _componentFactoryResolver, _validationErrorsConfig) || this;
            _this._elRef = _elRef;
            _this._renderer = _renderer;
            _this._messageProvider = _messageProvider;
            _this._cdRef = _cdRef;
            _this._componentFactoryResolver = _componentFactoryResolver;
            _this._validationErrorsConfig = _validationErrorsConfig;
            return _this;
        }
        Object.defineProperty(FormArrayContainerComponent.prototype, "formControl", {
            get: function () {
                return this._formControl.control;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayContainerComponent.prototype, "formControlName", {
            get: function () {
                return this._formControl.name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayContainerComponent.prototype, "statusChanges", {
            get: function () {
                return this._formControl.control.statusChanges;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormArrayContainerComponent.prototype, "el", {
            get: function () {
                return this._el;
            },
            enumerable: true,
            configurable: true
        });
        FormArrayContainerComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MESSAGES_PROVIDER,] }] },
            { type: core.ChangeDetectorRef },
            { type: core.ComponentFactoryResolver },
            { type: undefined, decorators: [{ type: core.Inject, args: [VALIDATION_ERROR_CONFIG,] }] }
        ]; };
        __decorate([
            core.ContentChild(forms.FormArrayName, { static: true })
        ], FormArrayContainerComponent.prototype, "_formControl", void 0);
        __decorate([
            core.ContentChild(forms.FormArrayName, { read: core.ElementRef, static: true })
        ], FormArrayContainerComponent.prototype, "_el", void 0);
        FormArrayContainerComponent = __decorate([
            core.Component({
                selector: '[ngxValidationErrorsArray], ngx-validation-errors-array, [formArrayContainer], form-array-container',
                template: "\n      <ng-content></ng-content>\n      <ng-container #errorsContainer></ng-container>\n  "
            }),
            __param(2, core.Optional()), __param(2, core.Inject(MESSAGES_PROVIDER)),
            __param(5, core.Inject(VALIDATION_ERROR_CONFIG))
        ], FormArrayContainerComponent);
        return FormArrayContainerComponent;
    }(FormValidationContainer));

    var ForFieldErrorsContext = /** @class */ (function () {
        function ForFieldErrorsContext(errors) {
            this.errors = errors;
        }
        return ForFieldErrorsContext;
    }());
    var FormFieldEmptyContainerDirective = /** @class */ (function () {
        function FormFieldEmptyContainerDirective(renderer, viewContainer, template, 
        // @Optional() form: FormGroupDirective,
        messageProvider, validationErrorsConfig) {
            this.renderer = renderer;
            this.viewContainer = viewContainer;
            this.template = template;
            this.messageProvider = messageProvider;
            this.validationErrorsConfig = validationErrorsConfig;
            this.customErrorMessages = {};
            this.messageParams = {};
            this.validationDisabled = false;
            this.context = { errors: [] };
            this.validationContext = validationErrorsConfig.defaultContext;
            var nodes = this.viewContainer.createEmbeddedView(this.template, this.context);
            this.rootEl = nodes.rootNodes[0];
        }
        FormFieldEmptyContainerDirective.prototype.ngDoCheck = function () {
            var _this = this;
            var hasError = (!this.formControl.valid && this.formControl.touched) && !this.validationDisabled;
            var messages;
            if (hasError) {
                messages = Object.keys(this.formControl.errors).map(function (error) {
                    var fieldName = _this.formControlName;
                    var errorKey = toScreamingSnakeCase(fieldName) + ".ERRORS." + toScreamingSnakeCase(error);
                    if (_this.messageProvider &&
                        _this.messageProvider.instant(_this.validationContext + "." + errorKey) === _this.validationContext + "." + errorKey) {
                        return _this.validationErrorsConfig.defaultContext + ".ERRORS." + toScreamingSnakeCase(error);
                    }
                    else {
                        return _this.validationContext + "." + errorKey;
                    }
                });
                var params = Object.values(this.formControl.errors).reduce(function (a, b) {
                    a = __assign(__assign({}, a), b);
                    return a;
                }, {});
                this.messageParams = this.messageParams ? __assign(__assign({}, this.messageParams), params) : params;
                if (messages && messages.length > 0) {
                    messages = [messages[0]];
                }
            }
            if ((messages && !this.messages) || (!messages && this.messages) || (messages && messages[0] !== this.messages[0])) {
                this.messages = messages;
                this.context.errors = messages;
                if (this.rootEl) {
                    if (messages) {
                        this.renderer.addClass(this.rootEl, 'has-error');
                    }
                    else {
                        this.renderer.removeClass(this.rootEl, 'has-error');
                    }
                }
            }
        };
        FormFieldEmptyContainerDirective.prototype.setValidationContext = function (context) {
            this.validationContext = context;
        };
        FormFieldEmptyContainerDirective.prototype.setInnerValidation = function (innerValidation) {
        };
        FormFieldEmptyContainerDirective.prototype.clear = function () {
            this.formControl.reset();
            this.formControl.setErrors(null);
            this.messages = [];
            this.context.errors = undefined;
        };
        Object.defineProperty(FormFieldEmptyContainerDirective.prototype, "formControl", {
            get: function () {
                return this.formControlRef;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FormFieldEmptyContainerDirective.prototype, "formControlName", {
            get: function () {
                var _this = this;
                if (this.formControlRef['_parent'] instanceof forms.FormGroup) {
                    var form_1 = this.formControlRef['_parent'];
                    var name_1 = Object.keys(form_1.controls).find(function (k) { return form_1.controls[k] === _this.formControlRef; });
                    return name_1;
                }
                return 'field';
            },
            enumerable: true,
            configurable: true
        });
        FormFieldEmptyContainerDirective.ctorParameters = function () { return [
            { type: core.Renderer2 },
            { type: core.ViewContainerRef },
            { type: core.TemplateRef },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MESSAGES_PROVIDER,] }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [VALIDATION_ERROR_CONFIG,] }] }
        ]; };
        __decorate([
            core.Input('ngxValidationErrors')
        ], FormFieldEmptyContainerDirective.prototype, "formControlRef", void 0);
        __decorate([
            core.Input()
        ], FormFieldEmptyContainerDirective.prototype, "customErrorMessages", void 0);
        __decorate([
            core.Input()
        ], FormFieldEmptyContainerDirective.prototype, "messageParams", void 0);
        __decorate([
            core.Input()
        ], FormFieldEmptyContainerDirective.prototype, "validationDisabled", void 0);
        FormFieldEmptyContainerDirective = __decorate([
            core.Directive({
                selector: '[ngxValidationErrors]',
                providers: [
                    {
                        provide: forms.ControlContainer,
                        useExisting: forms.FormGroupDirective
                    }
                ]
            }),
            __param(3, core.Optional()), __param(3, core.Inject(MESSAGES_PROVIDER)),
            __param(4, core.Inject(VALIDATION_ERROR_CONFIG))
        ], FormFieldEmptyContainerDirective);
        return FormFieldEmptyContainerDirective;
    }());

    var ValidationContextComponent = /** @class */ (function () {
        function ValidationContextComponent(cdRef) {
            this.cdRef = cdRef;
        }
        ValidationContextComponent.prototype.ngAfterContentInit = function () {
            var _this = this;
            if (this.fieldValidators) {
                this.fieldValidators.forEach(function (i) {
                    i.setValidationContext(_this.validationContext);
                    i.setInnerValidation(_this.innerValidationError);
                });
            }
            if (this.arrayValidators) {
                this.arrayValidators.forEach(function (i) {
                    i.setValidationContext(_this.validationContext);
                    i.setInnerValidation(_this.innerValidationError);
                });
            }
            if (this.directives) {
                this.directives.forEach(function (i) {
                    i.setValidationContext(_this.validationContext);
                    i.setInnerValidation(_this.innerValidationError);
                });
            }
        };
        ValidationContextComponent.prototype.clear = function () {
            if (this.fieldValidators) {
                this.fieldValidators.forEach(function (v) {
                    v.clear();
                });
            }
            if (this.arrayValidators) {
                this.arrayValidators.forEach(function (v) {
                    v.clear();
                });
            }
            if (this.directives) {
                this.directives.forEach(function (v) {
                    v.clear();
                });
            }
            this.cdRef.markForCheck();
        };
        ValidationContextComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.ContentChildren(FormFieldContainerComponent, { descendants: true })
        ], ValidationContextComponent.prototype, "fieldValidators", void 0);
        __decorate([
            core.ContentChildren(FormArrayContainerComponent, { descendants: true })
        ], ValidationContextComponent.prototype, "arrayValidators", void 0);
        __decorate([
            core.ContentChildren(FormFieldEmptyContainerDirective, { descendants: true })
        ], ValidationContextComponent.prototype, "directives", void 0);
        __decorate([
            core.Input()
        ], ValidationContextComponent.prototype, "validationContext", void 0);
        __decorate([
            core.Input()
        ], ValidationContextComponent.prototype, "innerValidationError", void 0);
        ValidationContextComponent = __decorate([
            core.Component({
                // tslint:disable:component-selector
                selector: '[validationContext]',
                template: '<ng-content></ng-content>'
            })
        ], ValidationContextComponent);
        return ValidationContextComponent;
    }());

    var InnerMapToMessagePipe = /** @class */ (function () {
        function InnerMapToMessagePipe() {
        }
        InnerMapToMessagePipe.prototype.transform = function (value, args) {
            return value;
        };
        InnerMapToMessagePipe = __decorate([
            core.Injectable(),
            core.Pipe({
                name: 'innerMapToMessage',
                pure: false
            })
        ], InnerMapToMessagePipe);
        return InnerMapToMessagePipe;
    }());

    var MapToMessagePipe = /** @class */ (function () {
        function MapToMessagePipe(cdRef, pipeFactory) {
            this.pipeFactory = pipeFactory;
            if (pipeFactory) {
                try {
                    this.pipe = pipeFactory(cdRef);
                }
                catch (e) {
                    console.error(e);
                    this.pipe = new InnerMapToMessagePipe();
                }
            }
            else {
                this.pipe = new InnerMapToMessagePipe();
            }
        }
        MapToMessagePipe.prototype.transform = function (value) {
            var _a;
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return (_a = this.pipe).transform.apply(_a, __spread([value], args));
        };
        MapToMessagePipe.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }] },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [MESSAGES_PIPE_FACTORY_TOKEN,] }] }
        ]; };
        MapToMessagePipe = __decorate([
            core.Pipe({
                name: 'mapToMessage',
                pure: false
            }),
            __param(0, core.Optional()),
            __param(1, core.Optional()), __param(1, core.Inject(MESSAGES_PIPE_FACTORY_TOKEN))
        ], MapToMessagePipe);
        return MapToMessagePipe;
    }());

    var defaultConfig = {
        defaultContext: 'GENERAL',
        errorComponent: InputErrorsComponent
    };
    function configFactory(customConfig, currentConfig) {
        var actualConfig = __assign({}, currentConfig);
        if (customConfig) {
            if (customConfig.defaultContext) {
                actualConfig.defaultContext = customConfig.defaultContext;
            }
            if (customConfig.errorComponent) {
                actualConfig.errorComponent = customConfig.errorComponent;
            }
        }
        return actualConfig;
    }
    var NgxValidationErrorsModule = /** @class */ (function () {
        function NgxValidationErrorsModule() {
        }
        NgxValidationErrorsModule_1 = NgxValidationErrorsModule;
        NgxValidationErrorsModule.forRoot = function (config) {
            return {
                ngModule: NgxValidationErrorsModule_1,
                providers: [
                    {
                        provide: ValidationErrorsConfigObject, useValue: defaultConfig
                    },
                    {
                        provide: FOR_ROOT_OPTIONS_TOKEN,
                        useValue: config
                    },
                    MapToMessagePipe,
                    {
                        provide: VALIDATION_ERROR_CONFIG,
                        useFactory: configFactory,
                        deps: [FOR_ROOT_OPTIONS_TOKEN, ValidationErrorsConfigObject]
                    },
                    MapToMessagePipe,
                    InnerMapToMessagePipe
                ]
            };
        };
        var NgxValidationErrorsModule_1;
        NgxValidationErrorsModule = NgxValidationErrorsModule_1 = __decorate([
            core.NgModule({
                declarations: [
                    InputErrorsComponent,
                    FormFieldContainerComponent,
                    FormFieldEmptyContainerDirective,
                    FormArrayContainerComponent,
                    ValidationContextComponent,
                    MapToMessagePipe,
                    InnerMapToMessagePipe
                ],
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    forms.ReactiveFormsModule
                ],
                exports: [
                    InputErrorsComponent,
                    FormFieldContainerComponent,
                    FormArrayContainerComponent,
                    ValidationContextComponent,
                    FormFieldEmptyContainerDirective
                ],
                entryComponents: [
                    InputErrorsComponent
                ]
            })
        ], NgxValidationErrorsModule);
        return NgxValidationErrorsModule;
    }());

    exports.ForFieldErrorsContext = ForFieldErrorsContext;
    exports.FormArrayContainerComponent = FormArrayContainerComponent;
    exports.FormFieldContainerComponent = FormFieldContainerComponent;
    exports.FormFieldEmptyContainerDirective = FormFieldEmptyContainerDirective;
    exports.InputErrorsComponent = InputErrorsComponent;
    exports.MESSAGES_PIPE_FACTORY_TOKEN = MESSAGES_PIPE_FACTORY_TOKEN;
    exports.MESSAGES_PROVIDER = MESSAGES_PROVIDER;
    exports.NgxValidationErrorsModule = NgxValidationErrorsModule;
    exports.ValidationContextComponent = ValidationContextComponent;
    exports.ɵa = defaultConfig;
    exports.ɵb = configFactory;
    exports.ɵc = ValidationErrorsConfigObject;
    exports.ɵd = FOR_ROOT_OPTIONS_TOKEN;
    exports.ɵe = FormValidationContainer;
    exports.ɵg = VALIDATION_ERROR_CONFIG;
    exports.ɵh = MapToMessagePipe;
    exports.ɵi = InnerMapToMessagePipe;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=xtream-ngx-validation-errors.umd.js.map
