import { ChangeDetectorRef, ComponentFactoryResolver, ElementRef, Renderer2 } from '@angular/core';
import { FormArrayName } from '@angular/forms';
import { FormValidationContainer } from './form-validation-container';
import { ValidationErrorsConfig } from './error-validation-config';
import { Observable } from 'rxjs';
export declare class FormArrayContainerComponent extends FormValidationContainer {
    private _elRef;
    private _renderer;
    private _messageProvider;
    private _cdRef;
    private _componentFactoryResolver;
    private _validationErrorsConfig;
    _formControl: FormArrayName;
    _el: ElementRef;
    constructor(_elRef: ElementRef, _renderer: Renderer2, _messageProvider: {
        instant(key: string): string;
    }, _cdRef: ChangeDetectorRef, _componentFactoryResolver: ComponentFactoryResolver, _validationErrorsConfig: ValidationErrorsConfig);
    get formControl(): import("@angular/forms").FormArray;
    get formControlName(): string | number;
    get statusChanges(): Observable<any>;
    get el(): ElementRef<any>;
}
