import { DoCheck, Renderer2, TemplateRef, ViewContainerRef } from '@angular/core';
import { AbstractControl } from '@angular/forms';
import { ValidationErrorsConfig } from './error-validation-config';
export declare class ForFieldErrorsContext {
    errors: string[];
    constructor(errors: string[]);
}
export declare class FormFieldEmptyContainerDirective implements DoCheck {
    private renderer;
    private viewContainer;
    private template;
    private messageProvider;
    private validationErrorsConfig;
    formControlRef: AbstractControl;
    customErrorMessages: {};
    messageParams: {};
    validationDisabled: boolean;
    rootEl: any;
    messages: string[];
    private validationContext;
    private context;
    constructor(renderer: Renderer2, viewContainer: ViewContainerRef, template: TemplateRef<ForFieldErrorsContext>, messageProvider: any, validationErrorsConfig: ValidationErrorsConfig);
    ngDoCheck(): void;
    setValidationContext(context: string): void;
    setInnerValidation(innerValidation: boolean): void;
    clear(): void;
    get formControl(): AbstractControl;
    get formControlName(): string;
}
