import { AfterContentInit, ChangeDetectorRef, QueryList } from '@angular/core';
import { FormFieldContainerComponent } from './form-field-container.component';
import { FormArrayContainerComponent } from './form-array-container.component';
import { FormFieldEmptyContainerDirective } from './form-field-empty-container.directive';
export declare class ValidationContextComponent implements AfterContentInit {
    private cdRef;
    fieldValidators: QueryList<FormFieldContainerComponent>;
    arrayValidators: QueryList<FormArrayContainerComponent>;
    directives: QueryList<FormFieldEmptyContainerDirective>;
    validationContext: string;
    innerValidationError: boolean;
    constructor(cdRef: ChangeDetectorRef);
    ngAfterContentInit(): void;
    clear(): void;
}
