import { InjectionToken } from '@angular/core';
export interface ErrorsComponent {
    innerValidationError: boolean;
    messages: string[];
    params: {
        [key: string]: any;
    };
}
export declare type ValidationErrorsConfig = {
    defaultContext?: string;
    errorComponent?: ErrorsComponent;
};
export declare const VALIDATION_ERROR_CONFIG: InjectionToken<ValidationErrorsConfig>;
